C ********************************************************************
C * BANDPLOT - Plotting and interpolation of energy bands            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  BPBRDR                                                          *
C *                                                                  *
C *  Routine of BANDPLOT                                             *
C *                                                                  *
C *  Usage......: Draws right border.                                *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs) c/o                          *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 28.04.92                                           *
C *  Revision...: 01.07.97/mbs                                       *
C *  Remarks....: Changed for use with PGPLOT graphics library.      *
C *                                                                  *
C *  Called from: BPGRPH                                             *
C *                                                                  *
C *  Calls......: PGPLOT routines PGSCI,PGSWIN,PGSVP,PGMOVE,PGDRAW   *
C *                                                                  *
C ********************************************************************

      SUBROUTINE BPBRDR(VPXOFF,VPYOFF,VPXAXW,VPYAXH,VPXEND,VPYEND)
C
C NAG/GKS version.
C
C      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C PGPLOT version.
C
      IMPLICIT REAL(A-H,O-Z)

      PARAMETER (MARGIN=0)

      IPEN=1
C
C Select pen.
C
C NAG/GKS version.
C
C      CALL J06YMF(IPEN)
C
C PGPLOT version.
C 
      CALL PGSCI(IPEN)
C
C Set data range and viewport.
C
C NAG/GKS version.
C
C      CALL J06WBF(0.0,VPXAXW,0.0,VPYAXH,MARGIN)
C      CALL J06WCF(VPXOFF,VPXEND,VPYOFF,VPYEND)
C
C PGPLOT version.
C 
      CALL PGSWIN(0.0,VPXAXW,0.0,VPYAXH)
      CALL PGSVP(VPXOFF,VPXEND,VPYOFF,VPYEND)
C
C Draw right border.
C
C NAG/GKS version.
C
C      CALL J06YAF(VPXAXW,0.0)
C      CALL J06YCF(VPXAXW,VPYAXH)
C      CALL J06YCF(0.0,VPYAXH)
C
C PGPLOT version.
C
      CALL PGMOVE(VPXAXW,0.0)
      CALL PGDRAW(VPXAXW,VPYAXH)
      CALL PGDRAW(0.0,VPYAXH)
C
C Use cheap trick for output of whole polyline buffer.
C
C NAG/GKS version.
C
C      CALL J06YAF(0.0,0.0)
C      CALL GUWK(1,1)
      RETURN
      END