C ********************************************************************
C * BANDPLOT - Plotting and interpolation of energy bands            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  BPTICS                                                          *
C *                                                                  *
C *  Routine of BANDPLOT                                             *
C *                                                                  *
C *  Usage......: Asks for location of energy axes tics.             *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs) c/o                          *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 03.03.92                                           *
C *  Revision...: 01.07.97/mbs                                       *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: BPGRPH                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE BPTICS(ITICSI)

      INTEGER ITICSI

      WRITE(6,10)
10    FORMAT(/,' Select axis side of tic marks ',
     .       /,' (0) No tic marks',
     .       /,' (1) Left side',
     .       /,' (2) Right side',
     .       /,' (3) Both sides',/)
20    WRITE(6,'('' Option: '',$)')
      READ(5,'(I2)',ERR=20) ITICSI
      IF ((ITICSI .LT. 0) .OR. (ITICSI .GT. 3)) GOTO 20
      RETURN
      END