C ********************************************************************
C * CEDiT - Crystal Electronic Dipole-induced Transitions            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  SUBROUTINE WRTKEY                                               *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       *
C *                                                                  *
C *  Usage......: Writes chosen KEYWRDs                              *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: December 1995                                      *
C *  Revision...: -                                                  *
C *                                                                  *
C *  Called from: GETSEL                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE WRTKEY(KEY,STRING)

      IMPLICIT NONE

      INCLUDE 'sizes'

        CHARACTER*(RECLEN)   KEY
        CHARACTER*(4*RECLEN) STRING 

C VAR
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      INTEGER IIN,IOUT,ISTART

      CHARACTER*(*) STAR
      PARAMETER (STAR = ' * ')

      CHARACTER*(*)  SEP, MARK
      PARAMETER (SEP = ':', MARK = '- ') 

      CHARACTER*(4*RECLEN) STR, OUTSTR1, OUTSTR2
      INTEGER STRLEN

C BEGIN
      IF (INDEX(KEY,'POL') .EQ. 1) THEN

        IF (STRING(3:3) .NE. ' ') THEN
          STR = STRING(1:1)//', '//STRING(2:2)//', and '
     .                     //STRING(3:3)//SEP
        ELSEIF (STRING(2:2) .NE. ' ') THEN
          STR = STRING(1:1)//', and '//STRING(2:2)//SEP
        ELSE
          STR = STRING(1:1)//SEP
        ENDIF
        WRITE(OUTSTR1, '(2A)' ) STAR, 'POL' 
        OUTSTR2 = MARK//STR(1:STRLEN(STR,SEP))
     .                //' transitions considered.'

      ELSEIF (INDEX(KEY,'MOFILE') .EQ. 1) THEN

        WRITE(OUTSTR1, '(A3, A6)' ) STAR, 'MOFILE'
        OUTSTR2 = MARK//STRING(1:STRLEN(STRING,' '))
 
      ELSEIF (INDEX(KEY,'GENFILE') .EQ. 1) THEN
        
        WRITE(OUTSTR1, '(A3, A7)' ) STAR, 'GENFILE'
        OUTSTR2 = MARK//STRING(1:STRLEN(STRING,' '))

      ELSEIF (INDEX(KEY,'MATRICE') .EQ. 1) THEN

        WRITE(OUTSTR1, '(A3, A7)' ) STAR, 'MATRICE'
        OUTSTR2 = MARK//STRING(1:STRLEN(STRING,' '))//' transition '//
     .            'elements are taken into account.'

      ELSEIF (INDEX(KEY,'SPECOUT') .EQ. 1) THEN
      
        WRITE(OUTSTR1, '(A3, A7)' ) STAR, 'SPECOUT'  
        OUTSTR2 = MARK//STRING(1:INDEX(STRING,'.'))//'eds'//
     .            ' will contain the spectrum.' 

      ELSEIF (INDEX(KEY,'CORRECT') .EQ. 1) THEN
     
        WRITE(OUTSTR1, '(A3, A7)' ) STAR, 'CORRECT'
        OUTSTR2 = MARK//'We correct for degenaracies ( TOL = '//
     .            STRING(1:STRLEN(STRING,' '))//' )'

      ELSEIF (INDEX(KEY,'TRANSOUT') .EQ. 1) THEN

        WRITE(OUTSTR1, '(A3, A8)' ) STAR, 'TRANSOUT'
        OUTSTR2 = MARK//'We print the chosen transitions.' 

      ELSEIF (INDEX(KEY,'MATOUT') .EQ. 1) THEN

        WRITE(OUTSTR1, '(A3, A6)' ) STAR, 'MATOUT'
        OUTSTR2 = MARK//'We print the transition matrix elements.' 

      ELSEIF (INDEX(KEY,'CRYST') .EQ. 1) THEN

        WRITE(OUTSTR1, '(A3, A5)' ) STAR, 'CRYST'
        OUTSTR2 = MARK//'Crystal calculation selected.'

      ENDIF 

      WRITE(IOUT, '(A15, 11X, A54)' ) OUTSTR1, OUTSTR2 
      RETURN
      END
C END
