C ********************************************************************
C * DOSPLOT -  Plots density of states (DOS)                         *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  DPBRDR                                                          *
C *                                                                  *
C *  Routine of DOSPLOT                                              *
C *                                                                  *
C *  Usage......: Adds border to DOS and COOP plots.                 *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs) c/o                          *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 28.04.92                                           *
C *  Revision...: 01.07.97/mbs                                       *
C *  Remarks....: Changed to PGPLOT graphics subroutine library.     *
C *                                                                  *
C *  Called from: DOSPLT,DPGRPH                                      *
C *                                                                  *
C *  Calls......: PGPLOT routines PGSLS,PGSWIN,PGSVP,PGMOVE,PGDRAW   *
C *                                                                  *
C ********************************************************************

      SUBROUTINE DPBRDR(VPXDOO,VPXDOW,VPXCOO,VPXCOW,VPYOFF,VPYAXH,
     .                  IBUFDS,IBUFCP)
C
C NAG/GKS version.
C
C      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C PGPLOT version.
C
      IMPLICIT REAL(A-H,O-Z)

      PARAMETER (MARGIN=0)

      VPYEND=VPYOFF+VPYAXH
C
C Select pen.
C
      IPEN=1
C
C NAG/GKS version.
C
C      CALL J06YMF(IPEN)
C
C PGPLOT version.
C
      CALL PGSLS(IPEN)

      IF (IBUFDS .GT. 0) THEN
        VPXEND=VPXDOO+VPXDOW
C
C Set datarange and viewport. Draw border.
C
C NAG/GKS version.
C
C        CALL J06WBF(VPXDOO,VPXEND,VPYOFF,VPYEND,MARGIN)
C        CALL J06WCF(VPXDOO,VPXEND,VPYOFF,VPYEND)
C        CALL J06YAF(VPXDOO,VPYEND)
C        CALL J06YDF(VPXDOW,0.0D0)
C        CALL J06YDF(0.0D0,-VPYAXH)
C
C PGPLOT version.
C
        CALL PGSWIN(VPXDOO,VPXEND,VPYOFF,VPYEND)
        CALL PGSVP(VPXDOO,VPXEND,VPYOFF,VPYEND)
        CALL PGMOVE(VPXDOO,VPYEND)
        CALL PGDRAW(VPXEND,VPYEND)
        CALL PGDRAW(VPXEND,VPYOFF)
C
C Output polyline buffer.
C
C NAG/GKS version.
C
C        CALL J06YAF(VPXDOO,VPYOFF)
C
C PGPLOT version.
C
        CALL PGMOVE(VPXDOO,VPYOFF)
      ENDIF
      IF (IBUFCP .GT. 0) THEN
        VPXEND=VPXCOO+VPXCOW
C
C Set datarange and viewport. Draw border.
C
C NAG/GKS version.
C
C        CALL J06WBF(VPXCOO,VPXEND,VPYOFF,VPYEND,MARGIN)
C        CALL J06WCF(VPXCOO,VPXEND,VPYOFF,VPYEND)
C        CALL J06YAF(VPXCOO,VPYEND)
C        CALL J06YDF(VPXCOW,0.0)
C        CALL J06YDF(0.0,-VPYAXH)
C
C PGPLOT version.
C
        CALL PGSWIN(VPXCOO,VPXEND,VPYOFF,VPYEND)
        CALL PGSVP(VPXCOO,VPXEND,VPYOFF,VPYEND)
        CALL PGMOVE(VPXCOO,VPYEND)
        CALL PGDRAW(VPXEND,VPYEND)
        CALL PGDRAW(VPXEND,VPYOFF)
C
C Output polyline buffer.
C
C NAG/GKS version.
C
C        CALL J06YAF(VPXCOO,VPYOFF)
C
C PGPLOT version.
C
        CALL PGMOVE(VPXCOO,VPYOFF)
      ENDIF
C
C NAG/GKS version.
C
C      CALL GUWK(1,1)
      RETURN
      END