C ********************************************************************
C * DOSPLOT -  Plots density of states (DOS)                         *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  DPRDRW                                                          *
C *                                                                  *
C *  Routine of DOSPLOT                                              *
C *                                                                  *
C *  Usage......: Redraws DOS/COOP graphs.                           *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs)                              *
C *  Available..: Calzaferri group, Institute for Inorganic and      *
C *               Physical Chemistry, University of Berne, Freiestr. *
C *               3, CH-3012 Berne, Switzerland                      *
C *  Date.......: 01.09.1994                                         *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: DOSPLT,DPGRPH                                      *
C *                                                                  *
C *  Calls......: DPPLOT,DPBRDR,DPAXES,DPTITL,DPTEXT,DPFRMI          *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE DPRDRW(VPXDOO,VPXDOW,VPXCOO,VPXCOW,VPXOFF,VPXAXW,
     .                  VPXFUL,VPYOFF,VPYAXH,VPYFUL,EMIN,EMAX,ENERGY,
     .                  EFERMI,ETCMIN,ETCMAX,ETCDIS,ETCDS2,DTCMIN,
     .                  DTCMAX,DTCDIS,DTCDS2,CTCMIN,CTCMAX,CTCDIS,
     .                  CTCDS2,XDOSMN,XDOSMX,XCOPMX,XRANGE,
     .                  DOSMN,DOSMX,COOPMX,TEXTXY,TXTANG,DOFFST,
     .                  NMESH,IBUFDS,IBUFCP,ITXT,ITSDLF,ITSDMD,ITSDRT,
     .                  ITSDUP,ITSDLO,ITSCUP,ITSCLO,ILTYPE,ISHADE,
     .                  IBFNDX,ITXPOS,CDOSTI,CCOPTI,CENETI,CTEXT,
     .                  BUFTIT,FSELEC,FARBTR,FCLOSE,FFLINE)
C
C NAG/GKS version. 
C 
C      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
C PGPLOT version.
C
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      DIMENSION    ENERGY(MXMESH),TEXTXY(MXTEXT,2),DOFFST(MAXBUF)
      DIMENSION    ILTYPE(2*MAXBUF),ISHADE(2*MAXBUF),IBFNDX(2*MAXBUF)
      DIMENSION    TXTANG(MXTEXT),ITXPOS(MXTEXT)
      LOGICAL      FARBTR(2*MAXBUF),FSELEC(MAXSEL),FCLOSE(2*MAXBUF),
     .             FARBIT,FFLINE
      CHARACTER*80 CDOSTI,CCOPTI,CENETI,CTEXT(MXTEXT)
      CHARACTER*72 STRING,BUFTIT(2*MAXBUF)
 
      IF (IBUFDS .GT. 0) THEN
        IFINDX=0
        IPLTTP=1
        XMAX=0.0
        CALL DPPLOT(VPXDOO,VPXDOW,VPYOFF,VPYAXH,EMIN,EMAX,ENERGY,XMAX,
     .              XRANGE,DOSMN,DOSMX,COOPMX,DOFFST,
     .              NMESH,IFINDX,IBUFDS,IBUFCP,IPLTTP,ILTYPE,ISHADE,
     .              IBFNDX,STRING,BUFTIT,FARBTR,FCLOSE,FARBIT)
      ENDIF
      IF (IBUFCP .GT. 0) THEN
        IFINDX=0
        IPLTTP=2
        XMAX=0.0
        CALL DPPLOT(VPXCOO,VPXCOW,VPYOFF,VPYAXH,EMIN,EMAX,ENERGY,XMAX,
     .              XRANGE,DOSMN,DOSMX,COOPMX,DOFFST,
     .              NMESH,IFINDX,IBUFDS,IBUFCP,IPLTTP,ILTYPE,ISHADE,
     .              IBFNDX,STRING,BUFTIT,FARBTR,FCLOSE,FARBIT)
      ENDIF
      IF (FSELEC(3)) CALL DPBRDR(VPXDOO,VPXDOW,VPXCOO,VPXCOW,VPYOFF,
     .                           VPYAXH,IBUFDS,IBUFCP)
      IF (FSELEC(4)) CALL DPAXES(VPXOFF,VPXDOO,VPXDOW,VPXCOO,VPXCOW,
     .                           VPYOFF,VPXAXW,VPYAXH,EMIN,EMAX,
     .                           ETCMIN,ETCMAX,ETCDIS,ETCDS2,XDOSMN,
     .                           XDOSMX,DTCMIN,DTCMAX,DTCDIS,DTCDS2,
     .                           XCOPMX,CTCMIN,CTCMAX,CTCDIS,CTCDS2,
     .                           IBUFDS,IBUFCP,ITSDLF,ITSDMD,ITSDRT,
     .                           ITSDUP,ITSDLO,ITSCUP,ITSCLO,FARBTR)
      IF (FSELEC(5)) CALL DPTITL(VPXDOO,VPXDOW,VPXCOO,VPXCOW,VPXOFF,
     .                           VPYOFF,VPYAXH,IBUFDS,IBUFCP,CDOSTI,
     .                           CCOPTI,CENETI)
      IF (FSELEC(6)) CALL DPTEXT(VPXFUL,VPYFUL,TEXTXY,TXTANG,ITXPOS,
     .                           ITXT,CTEXT)
      VPXEND=VPXOFF+VPXAXW
      VPYEND=VPYOFF+VPYAXH
      IF (FSELEC(10)) CALL DPFRMI(VPXOFF,VPYOFF,VPXFUL,VPYFUL,VPXAXW,
     .                            VPYAXH,VPXEND,VPYEND,EMIN,EMAX,
     .                            EFERMI,FFLINE)
      RETURN
      END