C ********************************************************************
C * DOSPLOT -  Plots density of states (DOS)                         *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  DPTICS                                                          *
C *                                                                  *
C *  Routine of DOSPLOT                                              *
C *                                                                  *
C *  Usage......: Asks for location of axes tics.                    *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs) c/o                          *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 28.04.92                                           *
C *  Revision...: -                                                  *
C *  Remarks....: Adapted from BPTICS. Which of vertical or horizon- *
C *               tal axis is selected depends on parameter ITICSI,  *
C *               in which also the tic side will be returned. It    *
C *               depends of the context in the calling subroutine,  *
C *               which axis the returned value shall be used.       *
C *                                                                  *
C *  Called from: DPGRPH                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE DPTICS(ITICSI)

      INTEGER ITICSI

      IF (ITICSI .EQ. 0) THEN
        WRITE(6,'('' Select axis side of tic marks '',/,
     .            '' (0) No tic marks'',/,
     .            '' (1) Left side'',/,
     .            '' (2) Right side'',/,
     .            '' (3) Both sides'',/)')
10      WRITE(6,'('' Option: '',$)')
        READ(5,'(I2)',ERR=10) ITICSI
        IF ((ITICSI .LT. 0) .OR. (ITICSI .GT. 3)) GOTO 10
      ELSE
        WRITE(6,'('' Select axis side of tic marks '',/,
     .            '' (0) No tic marks'',/,
     .            '' (1) Lower side'',/,
     .            '' (2) Upper side'',/,
     .            '' (3) Both sides'',/)')
20      WRITE(6,'('' Option: '',$)')
        READ(5,'(I2)',ERR=20) ITICSI
        IF ((ITICSI .LT. 0) .OR. (ITICSI .GT. 3)) GOTO 20
      ENDIF
      RETURN
      END