C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  EHMACC                                                          *
C *                                                                  *
C *  Usage......: Program for EXTENDED HUCKEL MOLECULAR AND CRYSTAL  *
C *               CALCULATIONS                                       *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, M. Evain, T. Hughbanks, M. Kertesz, *
C *               S. Wijeyesekera, C. Wilker, C. Zheng, R. Hoffmann  *
C *                                                                  *
C *               originally written by M.-H. Whangbo in the labora- *
C *               tory of R. Hoffmann, Dept of Chemistry, Cornell    *
C *               Univ, Ithaca N.Y., Dec 1976                        *
C *               later modified by T. Hughbanks, M. Kertesz,        *
C *               S. Wijeyesekera, C. Wilker, C. Zheng in the labo-  *
C *               ratory of R. Hoffmann, Dept of Chemistry, Cornell  *
C *               Univ, Ithaca N.Y.                                  *
C *               modified by M. Evain in the laboratory of M.-H.    *
C *               Whangbo, Dept of Chemistry, North Carolina State   *
C *               University, Raleigh N.C., Dec 1987                 *
C *                                                                  *
C *  Date.......: Dec. 1976                                          *
C *  Revision...: 4.05.92/mbs (Martin Braendle c/o Calzaferri group, *
C *               Inst. f. Inorg. and Phys. Chem., Freiestr. 3,      *
C *               CH-3012 Berne),24.08.94/mbs                        *
C *  Remarks....: File access of different operating systems has to  *
C *               be adjusted. Look for OPEN statement.              *
C *                                                                  *
C *  Calls......: PART1,PART2                                        *
C *                                                                  *
C ********************************************************************

      PROGRAM EHMACC

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
C
C VAX timer
C
C      CALL LIB$INIT_TIMER ()

      OPEN (UNIT=7,FILE='ehmacc.s07',FORM='unformatted',STATUS='new')
      OPEN (UNIT=9,FILE='ehmacc.s09',FORM='unformatted',STATUS='new')
      OPEN (UNIT=11,FILE='ehmacc.s11',FORM='unformatted',STATUS='new')
      OPEN (UNIT=13,FILE='ehmacc.s13',FORM='unformatted',STATUS='new')
      OPEN (UNIT=19,FILE='ehmacc.s19',FORM='unformatted',STATUS='new')
      OPEN (UNIT=20,FILE='ehmacc.s20',FORM='unformatted',STATUS='new')
      OPEN (UNIT=21,FILE='ehmacc.s21',FORM='unformatted',STATUS='new')
      OPEN (UNIT=22,FILE='ehmacc.s22',FORM='unformatted',STATUS='new')
      OPEN (UNIT=23,FILE='ehmacc.s23',FORM='unformatted',STATUS='new')
C
C Extensions for MS-DOS-version. Comment out for other operating systems.
C
      OPEN (UNIT=5,FILE='fort.5',FORM='formatted',STATUS='unknown')
      OPEN (UNIT=6,FILE='fort.6',FORM='formatted',STATUS='new')
      OPEN (UNIT=8,FILE='fort.8',FORM='formatted',STATUS='new')
      OPEN (UNIT=10,FILE='fort.10',FORM='formatted',STATUS='new')
      OPEN (UNIT=12,FILE='fort.12',FORM='formatted',STATUS='new')
      OPEN (UNIT=14,FILE='fort.14',FORM='formatted',STATUS='new')
      OPEN (UNIT=15,FILE='fort.15',FORM='formatted',STATUS='new')

      IIN = 5
      IOUT = 6

      WRITE(IOUT,10)
   10 FORMAT(//,' *************************************************',/,
     .          ' *                     EHMACC                    *',/,
     .          ' *             Release September 1997            *',/,
     .          ' * --------------------------------------------- *',/,
     .          ' *     Extended Hueckel Molecular and Crystal    *',/,
     .          ' *                  Calculations                 *',/,
     .          ' *     M.-H. Whangbo, M. Evain, T. Hughbanks,    *',/,
     .          ' *     M. Kertesz, S. Wijeyesekera, C. Wilker,   *',/,
     .          ' *           C. Zheng, and R. Hoffmann           *',/,
     .          ' *                                               *',/,
     .          ' *                 Extensions by                 *',/,
     .          ' *    M. Braendle, R. Rytz, and G. Calzaferri    *',/,
     .          ' *    Department of Chemistry and Biochemistry   *',/,
     .          ' *        University of Bern, Switzerland        *',/,
     .          ' *                                               *',/,
     .          ' *          (C) 1997 by Gion Calzaferri          *',/,
     .          ' *   EHMACC comes with absolutely no warranty.   *',/,
     .          ' * This is free software and you are welcome to  *',/,
     .          ' *   redistribute it under certain conditions.   *',/,
     .          ' *  For details see GNU General Public License.  *',/,
     .          ' *************************************************',/,
     .2X)

      CALL PART1
      CALL PART2

C      MIN=0
C      CALL LIB$STAT_TIMER(2,ICPU)
C      SEC=ICPU*0.01
C      IF (SEC .GE. 60.0) THEN
C        MIN=INT(SEC/60.)
C        SEC=SEC-60.0*MIN
C      END IF
C
C      WRITE (IOUT,20) MIN,SEC
C   20 FORMAT(//,' cpu time  ',I5,' min.  ',F5.2,' sec.')
C
C      MIN2=0
C      CALL LIB$STAT_TIMER (3,IIO)
C      SEC2=IIO*0.01
C      IF (SEC2 .GE. 60.0) THEN
C        MIN2=INT(SEC2/60.)
C        SEC2=SEC2-60.0*MIN2
C      ENDIF
C      WRITE(IOUT,30) MIN2, SEC2
C   30 FORMAT(' buffered I/O count ',I5,' min.  ',F5.2,' sec.')
C
C      MIN3=0
C      CALL LIB$STAT_TIMER (4,IIO)
C      SEC3=IIO*0.01
C      IF (SEC3 .GE. 60.0) THEN
C        MIN3=INT(SEC3/60.)
C        SEC3=SEC3-60.0*MIN3
C      ENDIF
C      WRITE(IOUT,40) MIN3, SEC3
C   40 FORMAT(' direct I/O count ',I5,' min.  ',F5.2,' sec.')

      CLOSE (7,STATUS='delete')
      CLOSE (9,STATUS='delete')
      CLOSE (11,STATUS='delete')
      CLOSE (13,STATUS='delete')
      CLOSE (19,STATUS='delete')
      CLOSE (20,STATUS='delete')
      CLOSE (21,STATUS='delete')
      CLOSE (22,STATUS='delete')
      CLOSE (23,STATUS='delete')
      CALL CLEXIT

      END
