C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  GETNAM                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Converts the atom names into a proper format.      *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: SEARCH                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE GETNAM(I,STRING,IT)
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      CHARACTER STRING*7,STRNG2*80
 
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
 
      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80

      IT=0 
      IIA=ICHAR('A')
      IIZ=ICHAR('Z')
      IF (ISTART(I) .EQ. 81) THEN
        IT=1
        RETURN
      ENDIF
      LEN=ISTART(I+1)-ISTART(I)
      IF (LEN .GT. 7) LEN=7
      STRNG2=SLINE(ISTART(I):ISTART(I+1)-1)
      IIS=ICHAR(STRNG2(2:2))
      IF ((IIS .LT. IIA) .OR. (IIS .GT. IIZ)) THEN
        DO 10 K=LEN,1,-1
          STRNG2(K+1:K+1)=STRNG2(K:K)
   10   CONTINUE
        STRNG2(1:1)=' '
      ENDIF
      IF (LEN .LT. 7) THEN
        DO 20 K=LEN+1,7
          STRNG2(K:K)=' '
   20   CONTINUE
      ENDIF
      DO 30 K=1,7
        STRING(K:K)=STRNG2(K:K)
   30 CONTINUE
      RETURN
      END
