C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  GETSEL                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Reads a title and all keywords.                    *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: PART1                                              *
C *                                                                  *
C *  Calls......: READL,WRITEL,WRTKEY                                *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE GETSEL
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      CHARACTER TITLE*131,SPACE*1
      COMMON /IOUNIT/ IIN,IOUT,ISTART(40)
 
      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80
 
      DATA SPACE /' '/
 
      TITLE=' '
      CALL READL
      IF (INDEX(SLINE,'TITLE') .NE. 0) THEN
        TITLE=SLINE
        TITLE(1:5)='     '
        CALL READL
      END IF
 
      KEYWRD=' '
      IP2=1
   10 IF (INDEX(SLINE,'KEYWRD') .EQ. 0) GOTO 40
      DO 20 I=80,ISTART(2),-1
        IF (SLINE(I:I) .NE. SPACE) GOTO 30
   20 CONTINUE
   30 KEYWRD=KEYWRD(1:IP2)//SLINE(ISTART(2):I)//' '
      IP2=IP2+I+2-ISTART(2)
      IF (IP2 .GE. 320) THEN
        SLINE='Too many keywords.'
        CALL WRITEL(SLINE)
        RETURN
      ENDIF
      CALL READL
      GOTO 10
   40 CONTINUE
C
C output
C
      WRITE(IOUT,50) TITLE
   50 FORMAT(/,' ',A,///)
      CALL WRTKEY
 
      RETURN
      END
