C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  HUCKEL                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Controls MO calculations.                          *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 12.06.92/mbs (Martin Braendle, c/o      *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, Ch-3012 Berne)                        *
C *  Remarks....: Output to unit 1 disabled. 12.06.92/mbs            *
C *                                                                  *
C *  Called from: ARRAYD                                             *
C *                                                                  *
C *  Calls......: CBORIS,WRITEL,OMATT3,POPULA,EHFMO                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE HUCKEL(DD,F,FF,V,VV,A,B,NDIM,NATOM)
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      DIMENSION DD(NDIM),F(NDIM,NDIM),FF(NDIM),V(NDIM,NDIM),VV(NDIM),
     .          A(NDIM,NDIM),B(NDIM,NDIM)
      INTEGER SORB(NATMMX)
 
      COMMON /AOOUT1/INDTS(NDIMMX)
      COMMON /ATOM1/NS(NSYMMX,NAEQMX),NP(NSYMMX),ND(NSYMMX),NF(NSYMMX),
     .              INATOM, ISYM(NATMMX),NELEM
      COMMON /ATOM2/EXPS(NSYMMX,NAEQMX),EXPS2(NSYMMX,NAEQMX),
     .              EXPP(NSYMMX),EXPP2(NSYMMX),
     .              EXPD(NSYMMX),EXPD2(NSYMMX),
     .              EXPF(NSYMMX),EXPF2(NSYMMX),
     .              CS1(NSYMMX,NAEQMX),CS2(NSYMMX,NAEQMX),
     .              CP1(NSYMMX),CP2(NSYMMX),CD1(NSYMMX),CD2(NSYMMX),
     .              CF1(NSYMMX),CF2(NSYMMX),COULS(NSYMMX,NAEQMX),
     .              COULP(NSYMMX),COULD(NSYMMX),COULF(NSYMMX),
     .              X(NATMMX),Y(NATMMX),Z(NATMMX)
      COMMON /DELET/IND(NDIMMX),INDIM,IVAL,NORBE(NATMMX),NDEL
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /OPTV/RHO,FERMI,WSTART,WEND,DISTL,LB,LE,LBR,LER,IOVLB,
     .             IOVLE,ICHARG,NELEC,IDISTN,IEB,IEE,ISB,ISE,IHB,IHE,
     .             IPOPE,JPOPE,IREST,IRESTV
      COMMON /TEMP1/NORBEF(NATMMX)
 
      COMMON /AELCON/AOOCC(NATMMX,4),USECON(NATMMX)
      LOGICAL USECON

      COMMON /AOOUT2/INDT(NDIMMX,2)
      CHARACTER INDT*10
 
      COMMON /ATO/AC(NATMMX),SYMBOL(NSYMMX)
      CHARACTER AC*7,SYMBOL*2

      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80
  
      DATA PI /3.1415926535898D0/
 
      NVAL=IVAL
      MOOUT=0
      IF (INDEX(KEYWRD,'MOOUT') .NE. 0) MOOUT=MOOUT+1
      IF (INDEX(KEYWRD,'AOOUT') .NE. 0) MOOUT=MOOUT+1
 
      IF (LB .EQ. 0) LB=1
      IF (LE .EQ. 0) LE=NDIM
      IF (IEB .EQ. 0) IEB=1
      IF (IEE .EQ. 0) IEE=NDIM
 
      WRITE(IOUT,10)
   10 FORMAT(/,1X,131('-'),/,5X,'Molecular calculation',//)
 
      ND1=NDIM-1
      READ(21) (SORB(I),I=1,NATOM),B
      REWIND 21
      READ(22) (SORB(I),I=1,NATOM),A
      REWIND 22
 
      DO 20 M=1,ND1
        M1=M+1
        DO 20 N=M1,NDIM
          A(M,N)=0.0D0
          B(M,N)=0.0D0
   20 CONTINUE
 
      CALL CBORIS(NDIM,NDIM,A,B,V,DD,FF,VV,IFAIL)
      IF (IFAIL .NE. 0) THEN
        SLINE='Orbitals too diffuse, more overlap may be needed.'
        CALL WRITEL(SLINE)
      ENDIF
C
C output for plot
C
C      NKP=3
C      WRITE(1) NKP,NDIM,NATOM
C      WRITE(1) INDT,AC,SYMBOL,NS,NP,ND,NF,NELEM,IND,NORBEF,NORBE,
C     .         NDEL
C      WEIGHT=0.0D0
C      XK=0.0D0
C      WRITE(1) XK,XK,XK,WEIGHT,DD
C      XK=PI*0.5D0
C      WRITE(1) XK,XK,XK,WEIGHT,DD
C      XK=PI
C      WRITE(1) XK,XK,XK,WEIGHT,DD
C
C molecular energies and state
C
      IST=0
      NFULL=NVAL/2
      IEVEN=0
      IF (NVAL .EQ. NFULL*2) IEVEN=1
 
      IST1=INDEX(KEYWRD,'SINGLET')
      IF (IST1 .NE. 0) IST=1
      IST2=INDEX(KEYWRD,'DOUBLET')
      IF (IST2 .NE. 0) IST=2
      IST3=INDEX(KEYWRD,'TRIPLET')
      IF (IST3 .NE. 0) IST=3
      IST4=INDEX(KEYWRD,'QUARTET')
      IF (IST4 .NE. 0) IST=4
      IST5=INDEX(KEYWRD,'QUINTET')
      IF (IST5 .NE. 0) IST=5
      IST6=INDEX(KEYWRD,'SEXTET')
      IF (IST6 .NE. 0) IST=6
 
      IF ((IST .EQ. 0) .AND. (NVAL .EQ. NFULL*2)) IST=1
      IF ((IST .EQ. 0) .AND. (NVAL .NE. NFULL*2)) IST=2
      IST=IST-1
      IF (IEVEN .EQ. 1) THEN
        IF ((IST .EQ. 5) .OR. (IST .EQ. 3) .OR. (IST .EQ. 1)) IST=IST-1
      ELSE
        IF ((IST .EQ. 4) .OR. (IST .EQ. 2) .OR. (IST .EQ. 0)) IST=IST+1
      ENDIF
      NFULL=(NVAL-IST)/2
 
      WRITE(IOUT,30)
   30 FORMAT(//,5X,'Molecular orbital energies',/)
 
      DO 60 I=IEB,IEE
        WRITE(IOUT,40) I,DD(I)
   40   FORMAT(25X,I3,F12.6)
        IF (I .EQ. NFULL) WRITE(IOUT,50)
        IF ((IST .NE. 0) .AND. (I .EQ. (NFULL+IST))) WRITE(IOUT,50)
   50   FORMAT(' ')
   60 CONTINUE
 
      SUME=0.0D0
      DO 70 I=1,NFULL
   70 SUME=SUME+DD(I)*2.0
      WRITE(IOUT,80) SUME,NFULL
   80 FORMAT(/,5X,'Total energy      ',F15.4,'   (',I3,
     .       ' doubly filled levels)')
 
      IF (IST .GT. 0) THEN
        DO 100 IJ=1,IST
          SUME=SUME+DD(NFULL+IJ)
          WRITE(IOUT,90) DD(NFULL+IJ),SUME
   90   FORMAT(5X,'                + ',F15.4,'=',F15.4)
  100   CONTINUE
      ENDIF

      EAOORB=0.0D0
      ESTAB=0.0D0
      IF ((INDEX(KEYWRD,'EAAORB') .GT. 0) .OR.
     .    (INDEX(KEYWRD,'REPUL') .GT. 0)) THEN
        DO 101 I=1,INATOM
          KEYI=ISYM(I)
          EAOORB=EAOORB+AOOCC(I,1)*COULS(KEYI,1)+AOOCC(I,2)*COULP(KEYI)+
     .           AOOCC(I,3)*COULD(KEYI)+AOOCC(I,4)*COULF(KEYI)
  101   CONTINUE
        WRITE(IOUT,102) EAOORB
  102   FORMAT(/,5X,'Sum over occupied atomic energy levels   = ',F10.5)
        ESTAB=SUME-EAOORB
        WRITE(IOUT,103) ESTAB
  103   FORMAT(/,5X,'Orbital stabilization energy             = ',F10.5)
      ENDIF
 
      IF (INDEX(KEYWRD,'REPUL') .GT. 0) THEN
        CALL REPUL(EREP)
        WRITE(IOUT,104) EREP
  104   FORMAT(/,5X,'Electrostatic core-core repulsion energy = ',F10.5)
        ETOT=ESTAB+EREP
        WRITE(IOUT,105) ETOT
  105   FORMAT(/,5X,'Total energy  Etot = Estab+Erep          = ',F10.5)  
      ENDIF
        
 
  110 WRITE(11) A
 
      IF (MOOUT .EQ. 0) GOTO 140
      IOM=0
      DO 120 I=1,NDIM
        IOM=IOM+INDTS(I)
  120 CONTINUE
      IF (IOM .EQ. 0) GOTO 140
 
      WRITE(IOUT,130)
  130 FORMAT(//,5X,'Molecular orbitals',/)
      CALL OMATT3(DD,A,NDIM,LBR,LER,LB,LE,INDTS,1)
 
  140 CONTINUE
 
      IAOPOP=INDEX(KEYWRD,'AOPOP')
      IF (IAOPOP .NE. 0) CALL POPULA(F,A,V,FF,NDIM,NATOM,NVAL,IST)
 
      IF (INDEX(KEYWRD,'FMO') .EQ. 0) RETURN
 
      CALL EHFMO(DD,FF,V,VV,A,B,NDIM,NATOM)
      RETURN
      END
