C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  MATPAC                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Various matrix multiplications.                    *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....:                                                    *
C *                                                                  *
C *  Called from: EHFMO                                              *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE MATPAC(A,B,C,NX,NI,NJ,NM,IQ)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      DIMENSION A(NX,NX),B(NX,NX),C(NX,NX)

      DATA ZERO /0.0D0/
 
      GOTO (10,30,50),IQ
   10 DO 20 I=1,NI
        DO 20 J=1,NJ
          C(I,J)=ZERO
          DO 20 M=1,NM
   20 C(I,J)=C(I,J)+A(I,M)*B(M,J)
      RETURN

   30 DO 40 I=1,NI
        DO 40 J=1,NJ
          C(I,J)=ZERO
          DO 40 M=1,NM
   40 C(I,J)=C(I,J)+A(M,I)*B(M,J)
      RETURN

   50 DO 60 I=1,NI
        DO 60 J=1,NJ
          C(I,J)=ZERO
          DO 60 M=1,NM
   60 C(I,J)=C(I,J)+A(I,M)*B(J,M)
      RETURN

      END
