C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  OMFRAG                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Output routine for fragments.                      *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 06.05.92/mbs (Martin Braendle, c/o      *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne)                        *
C *  Remarks....: Slight modification of COMMON blocks.              *
C *                                                                  *
C *  Called from: BFMO                                               *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE OMFRAG(X,NN)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      DIMENSION X(NN,NN)

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /FMOIO/IFMOIN(NDIMMX,NFMOMX),IFMOO(NDIMMX,NFMOMX),
     .              NDIMFR(NFMOMX),IFMOP(11,NFMOMX),NFMO
      COMMON /OPTV/RHO,FERMI,WSTART,WEND,DISTL,LB,LE,LBR,LER,IOVLB,
     .             IOVLE,ICHARG,NELEC,IDISTN,IEB,IEE,ISB,ISE,IHB,IHE,
     .             IPOPE,JPOPE,IREST,IRESTV

      IF (JPOPE .EQ. 0) JPOPE=NN
      LEE=LE
      IF (LEE .GT. JPOPE) LEE=JPOPE
      IFLAG=1
      ILOWER=LB
      NL=LEE

   10 IUPPER=ILOWER+11
      IF (IUPPER-NL) 30,20,20
   20 IUPPER=NL
      IFLAG=0
   30 WRITE(IOUT,40) (J,J=ILOWER,IUPPER)
   40 FORMAT(/,23X,12I8)

      IL1=ILOWER
      IU1=IUPPER

      NUMBF=0
      INF=0
      DO 70 I=1,NN
        IF ((INF .EQ. 0) .OR. (INF .GT. NDIMFR(NUMBF))) THEN
          INF=1
          NUMBF=NUMBF+1
          WRITE(IOUT,50) NUMBF,INF,I,(X(I,J),J=IL1,IU1)
   50     FORMAT(/,1X,'Fragment #',I2,2X,I3,2X,I3,2X,12F8.4)
        ELSE
          WRITE(IOUT,60) INF,I,(X(I,J),J=IL1,IU1)
   60     FORMAT(15X,I3,2X,I3,2X,12F8.4)
        ENDIF
        INF=INF+1
   70 CONTINUE
      WRITE(IOUT,80)
   80 FORMAT(' ')

      IF (IFLAG) 90,100,90
   90 ILOWER=ILOWER+12
      GOTO 10

  100 RETURN
      END
