C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  PART1                                                           *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: 1st part of the band structure calculation prog-   *
C *               ram, controls all the options for the calculation. *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 06.05.92/mbs, 11.03.93/mbs (Martin      *
C *               Braendle c/o Calzaferri group, Inst. f. Inorg. and *
C *               Phys. Chem., Freiestr. 3, CH-3012 Berne)           *
C *  Remarks....: Slight modifications of COMMON blocks.             *
C *               Symmetry analysis of wavefunctions.                *
C *                                                                  *
C *  Called from: EHMACC                                             *
C *                                                                  *
C *  Calls......: GETSEL,GETPOS,BUILDZ,INMODI,PARAM,AOOUT,SHOUT,     *
C *               GETFMO,GETSYM,GETKP,GETVAR,VARYGM,CLEXIT           *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE PART1
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      COMMON /ATOM2/EXPS(NSYMMX,NAEQMX),EXPS2(NSYMMX,NAEQMX),
     .              EXPP(NSYMMX),EXPP2(NSYMMX),EXPD(NSYMMX),
     .              EXPD2(NSYMMX),EXPF(NSYMMX),EXPF2(NSYMMX),
     .              CS1(NSYMMX,NAEQMX),CS2(NSYMMX,NAEQMX),
     .              CP1(NSYMMX),CP2(NSYMMX),CD1(NSYMMX),CD2(NSYMMX),
     .              CF1(NSYMMX),CF2(NSYMMX),COULS(NSYMMX,NAEQMX),
     .              COULP(NSYMMX),COULD(NSYMMX),COULF(NSYMMX),
     .              C(NATMMX,3)
 
      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80
 
      COMMON/SYMANA/TRANSV(MXSYME,3),SYMOP(MXSYME,3,3),
     .              IPERMU(MXSYME,NATMMX,2),ISYMRE(MXSYME,NDIMMX),
     .              NLINOP(3),IPOINT(3,MXSYME),ILINE(3),NSYMEL,
     .              CSYMEL(MXSYME),FSYMOP(MXSYME),FSYMAN(MXSYME),FSYM
      LOGICAL   FSYMOP,FSYM,FSYMAN
      CHARACTER CSYMEL*2
 
      COMMON /VARGEO/VARINC(NVARMX),IVRLIN(NVARMX),ISTPMX(NVARMX),
     .               IVARTP(NVARMX),ISTEPS(NVARMX),IVARY,NVARY,
     .               NVARLN,NNCPL,LCOUPL(NVARMX+1)
      LOGICAL LCOUPL
 
 
C
C  options
C
      CALL GETSEL
C
C  inputs
C
      ICHO=0
      IF (INDEX(KEYWRD,'XYZ') .NE. 0) ICHO=1
      IF (INDEX(KEYWRD,'FRACT') .NE. 0) THEN
        CALL GETLAT
        ICHO=2
      ENDIF
      CALL GETPOS(ICHO)
      IF (INDEX(KEYWRD,'FRACT') .NE. 0) CALL FTOCAR(C)
      IF (INDEX(KEYWRD,'ZMAT') .NE. 0) CALL BUILDZ(C)
      CALL INMODI
      IVARY=1
      IF (INDEX(KEYWRD,'VARIATION') .GT. 0) CALL GETVAR
      CALL PARAM
      CALL AOOUT
      CALL SHOUT
      CALL GETFMO
      IF (FSYM) CALL GETSYM
      ICHECK=INDEX(KEYWRD,'CHECKFILE')
      IEND=1
      IF (INDEX(KEYWRD,'BAND') .NE. 0) CALL GETKP(IEND)
 
      IF (ICHECK .NE. 0) THEN
10      IF (IVARY .LT. NVARY) THEN
          IVARY=IVARY+1
          CALL VARYGM
        ENDIF
        IF (IVARY .LT. NVARY) GOTO 10
        CALL CLEXIT
      ENDIF
      RETURN
      END