C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  SHOUT                                                           *
C *                                                                  *
C *  Routine of                                                      *
C *                                                                  *
C *  Usage......: Gets output information for Hij,Sij,H(k),S(k)      *
C *               matrix elements.                                   *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 07.05.92/mbs (Martin Braendle, c/o      *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne), 25.09.92/mbs          *
C *  Remarks....: Slight modification of COMMON blocks.              *
C *               Addition of new cards SKOUT,HKOUT. 25.09.92/mbs    * 
C *                                                                  *
C *  Called from: PART1                                              *
C *                                                                  *
C *  Calls......: ADDK,SEARCH,READL                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE SHOUT 

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      CHARACTER*7  ELEM(NSYMMX)
      CHARACTER*10 TEXTF(20)
      CHARACTER    TEX1*11,TEX2*11,MOT*12

      COMMON /DELET/IND(NDIMMX),INDIM,IVAL,NORBE(NATMMX),NDEL
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /OPTV/RHO,FERMI,WSTART,WEND,DISTL,LB,LE,LBR,LER,IOVLB,
     .             IOVLE,ICHARG,NELEC,IDISTN,IEB,IEE,ISB,ISE,IHB,IHE,
     .             IPOPE,JPOPE,IREST,IRESTV
      COMMON /OPTV2/IHKB,IHKE,ISKB,ISKE
      COMMON /SHOUTP/ISOUT(NDIMMX),IHOUT(NDIMMX),ISKOUT(NDIMMX),
     .               IHKOUT(NDIMMX)
      COMMON /TEMP1/NORBEF(NATMMX)

      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80

      LDIM=INDIM-NDEL
      DO 10 I=1,LDIM
        ISOUT(I)=1
        IHOUT(I)=1
        ISKOUT(I)=1
        IHKOUT(I)=1
   10 CONTINUE
C
C Sij
C
      IF (INDEX(SLINE,'SOUT') .EQ. 0) GOTO 70
      MOT='SOUT'
      IF (INDEX(KEYWRD,'SOUT') .EQ. 0) CALL ADDK(MOT)

      WRITE(IOUT,20)
   20 FORMAT(' ')
      DO 30 I=1,LDIM
        ISOUT(I)=0
   30 CONTINUE

   40 IF (INDEX(SLINE,'SOUT') .EQ. 0) GOTO 60
      CALL SEARCH(TEXTF,NN,ELEM,KK,NORBEF,IND,NORBE,ISOUT)
      CALL READL
      TEXTF(1)=' SOUT '
      TEX1=' orbital : '
      TEX2=' element : '
      WRITE(IOUT,50) TEXTF(1),TEX2, (ELEM(L),L=1,KK),TEX1,
     .               (TEXTF(L),L=2,NN)
   50 FORMAT(1X,131A)
      GOTO 40

   60 CONTINUE
   70 IF (ISB .EQ. 0) ISB=1
      IF (ISE .EQ. 0) ISE=LDIM
      NN=0
      DO 80 I=1,LDIM
        IF ((I .LT. ISB) .OR. (I .GT. ISE)) THEN
          ISOUT(I)=0
        ELSE
          IF (ISOUT(I) .EQ. 1) NN=NN+1
        ENDIF
   80 CONTINUE
      IF (MOT .EQ. 'SOUT') WRITE(IOUT,90) NN,NN
   90 FORMAT(2X,' SOUT  : ',I3,' x ',I3,' matrix')
C
C Hij
C
      IF (INDEX(SLINE,'HOUT') .EQ. 0) GOTO 130
      MOT='HOUT'
      IF (INDEX(KEYWRD,'HOUT') .EQ. 0) CALL ADDK(MOT)

      WRITE(IOUT,20)
      DO 100 I=1,LDIM
        IHOUT(I)=0
  100 CONTINUE

  110 IF (INDEX(SLINE,'HOUT') .EQ. 0) GOTO 120
      CALL SEARCH(TEXTF,NN,ELEM,KK,NORBEF,IND,NORBE,IHOUT)
      CALL READL
      TEXTF(1)=' HOUT '
      TEX1=' orbital : '
      TEX2=' element : '
      WRITE(IOUT,50) TEXTF(1),TEX2,(ELEM(L),L=1,KK),TEX1, 
     .               (TEXTF(L),L=2,NN)
      GOTO 110

  120 CONTINUE
  130 IF (IHB .EQ. 0) IHB=1
      IF (IHE .EQ. 0) IHE=LDIM
      NN=0
      DO 140 I=1,LDIM
        IF ((I .LT. IHB) .OR. (I .GT. IHE)) THEN
          IHOUT(I)=0
        ELSE
          IF (IHOUT(I) .EQ. 1) NN=NN+1
        ENDIF
  140 CONTINUE
      IF (MOT .EQ. 'HOUT') WRITE(IOUT,150) NN,NN
  150 FORMAT(2X,' HOUT  : ',I3,' x ',I3,' matrix')
C
C S(k)
C
      IF (INDEX(SLINE,'SKOUT') .EQ. 0) GOTO 190
      MOT='SKOUT'
      IF (INDEX(KEYWRD,'SKOUT') .EQ. 0) CALL ADDK(MOT)

      WRITE(IOUT,20)
      DO 160 I=1,LDIM
        ISKOUT(I)=0
  160 CONTINUE

  170 IF (INDEX(SLINE,'SKOUT') .EQ. 0) GOTO 180
      CALL SEARCH(TEXTF,NN,ELEM,KK,NORBEF,IND,NORBE,ISKOUT)
      CALL READL
      TEXTF(1)=' SKOUT '
      TEX1=' orbital : '
      TEX2=' element : '
      WRITE(IOUT,50) TEXTF(1),TEX2,(ELEM(L),L=1,KK),TEX1,
     .               (TEXTF(L),L=2,NN)
      GOTO 170

  180 CONTINUE
  190 IF (ISKB .EQ. 0) ISKB=1
      IF (ISKE .EQ. 0) ISKE=LDIM
      NN=0
      DO 200 I=1,LDIM
        IF ((I .LT. ISKB) .OR. (I .GT. ISKE)) THEN
          ISKOUT(I)=0
        ELSE
          IF (ISKOUT(I) .EQ. 1) NN=NN+1
        ENDIF
  200 CONTINUE
      IF (MOT .EQ. 'SKOUT') WRITE(IOUT,210) NN,NN
  210 FORMAT(2X,' SKOUT  : ',I3,' x ',I3,' matrix')
C
C H(k)
C
      IF (INDEX(SLINE,'HKOUT') .EQ. 0) GOTO 250
      MOT='HKOUT'
      IF (INDEX(KEYWRD,'HKOUT') .EQ. 0) CALL ADDK(MOT)

      WRITE(IOUT,20)
      DO 220 I=1,LDIM
        IHKOUT(I)=0
  220 CONTINUE

  230 IF (INDEX(SLINE,'HKOUT') .EQ. 0) GOTO 240
      CALL SEARCH(TEXTF,NN,ELEM,KK,NORBEF,IND,NORBE,IHKOUT)
      CALL READL
      TEXTF(1)=' HKOUT '
      TEX1=' orbital : '
      TEX2=' element : '
      WRITE(IOUT,50) TEXTF(1),TEX2,(ELEM(L),L=1,KK),TEX1, 
     .               (TEXTF(L),L=2,NN)
      GOTO 230

  240 CONTINUE
  250 IF (IHKB .EQ. 0) IHKB=1
      IF (IHKE .EQ. 0) IHKE=LDIM
      NN=0
      DO 260 I=1,LDIM
        IF ((I .LT. IHKB) .OR. (I .GT. IHKE)) THEN
          IHKOUT(I)=0
        ELSE
          IF (IHKOUT(I) .EQ. 1) NN=NN+1
        ENDIF
  260 CONTINUE
      IF (MOT .EQ. 'HKOUT') WRITE(IOUT,270) NN,NN
  270 FORMAT(2X,' HKOUT  : ',I3,' x ',I3,' matrix')

      RETURN
      END
