C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  TEMPO                                                           *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Does temporal buffering of output variable.        *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: HMAT                                               *
C *                                                                  *
C *  Calls......: OMATT2                                             *
C *                                                                  *
C ********************************************************************

      SUBROUTINE TEMPO(X,NDIM,Y,NLIM,IB,IE,IOUT)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      DIMENSION X(NDIM,NDIM),Y(NLIM,NLIM),IOUT(NDIMMX)

      DO 20 I=1,NLIM
        DO 10 J=1,NLIM
          Y(I,J)=X(I,J)
   10   CONTINUE
   20 CONTINUE
      CALL OMATT2(Y,NLIM,IB,IE,IB,IE,IOUT,IOUT,1,1)
      RETURN
      END
