C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  WRITEL                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Writes error messages.                             *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: GETSEL,GETPOS,INMODI,GETNUM,RBOND,PARAM,GETFMO,    *
C *               GETKP,ARRAYS,EHFMO,HUCKEL                          *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE WRITEL(L)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      CHARACTER L*80

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)

      COMMON /KEYWRD/ KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80

      DO 10 I=80,1,-1
        IF (L(I:I) .NE. ' ') THEN
          IL=I
          GOTO 20
        ENDIF
   10 CONTINUE
   20 CONTINUE
C
C ****** for standard fortran 77 replace <il> by 80 ********
C
      WRITE(IOUT,30)
   30 FORMAT(/,1X,80('*'),/)
      WRITE(IOUT,40) L
   40 FORMAT(1X,A)
      WRITE(IOUT,30)
      IF (INDEX(KEYWRD,'FORCE') .EQ. 0) THEN
        STOP
      ELSE
        RETURN
      ENDIF
      END
