C ********************************************************************
C * EHPC - Extended Hueckel properties calculations                  *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  PROJTB                                                          *
C *                                                                  *
C *  Routine of EHPC                                                 *
C *                                                                  *
C *  Usage......: Does the integration for the overlap populations   *
C *               between atoms as a function of electron filling.   *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 10.04.92/mbs, 19.09.94/mbs (Martin      *
C *               Braendle c/o Calzaferri group, Inst. f. Inorg. and *
C *               Phys. Chem., Freiestr. 3, CH-3012 Berne)           *
C *  Remarks....: Formatted input will be read.                      *
C *                                                                  *
C *  Called from: PPART                                              *
C *                                                                  *
C *  Calls......: WRITEL                                             *
C *                                                                  *
C ********************************************************************

      SUBROUTINE PROJTB(W,IACC,B1,B2,B3,B5,B6,NDIM,NKP,NDK,NSTEP,IVARY)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      DIMENSION    W(NDK),IACC(NKP,NSTEP),B1(NSTEP),B2(NSTEP),B3(NSTEP),
     .             B5(NSTEP),B6(NSTEP)
      CHARACTER*80 CDUMMY
      CHARACTER*7  ACI1,ACI2,ACJ1,ACJ2
      LOGICAL      T1,T2,T3,T4,T5

      COMMON /BOND1/IDAT(NBONMX,2)
      CHARACTER*7 IDAT

      COMMON /BOND2/DDX(NBONMX),NDIVIS(NBONMX),NEQU
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)

      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80

      COMMON /OPTV/DELTA,EMIN,EMAX,STEP,XLIMIT,LEVB,LEVE,NMESH,IVARYS,
     .             IVARYE,NVARY
      COMMON /OVLP/IPROJB(NBONMX,MXCARD),NDPRB(MXCARD),NPROJB,
     .             NBTOT(MXCARD)

      COMMON /OVLPRO/DTMIN(NBONMX,MXCARD),DTMAX(NBONMX,MXCARD),
     .               IDMAX(MXCARD),NOM1(NBONMX,MXCARD),
     .               NOM2(NBONMX,MXCARD)
      CHARACTER*7 NOM1,NOM2

      COMMON /POP/DD(NBONMX,NDIMMX)

      IAV=INDEX(KEYWRD,'AVERAGE')

      IF ((IVARY .EQ. IVARYS) .AND. (IVARYS .GT. 1)) THEN
        DO 80 IVARCT=1,IVARYS-1
          READ(3,10) NEQU
   10     FORMAT(I4)
          DO 70 K=1,NKP
            READ(3,20) IOVLB, IOVLE
   20       FORMAT(2I4)
            ILOOP=IOVLE-IOVLB+2
            IF (IOVLB .EQ. 1) ILOOP=ILOOP-1
            IF (K .EQ. 1) THEN
              DO 40 IB=1,NEQU
                READ(3,30) CDUMMY
   30           FORMAT(A80)
   40         CONTINUE
            ENDIF
            DO 60 IL=1,ILOOP
              READ(3,50) (DD(IDD,IL),IDD=1,NEQU)
C
C old version files (prior to 29.06.93)/mbs
C   50         FORMAT(F10.5)
C
   50         FORMAT(F8.5)
   60       CONTINUE
   70     CONTINUE
   80   CONTINUE
      ENDIF

      REWIND 8
      READ(3,10) NEQU
      DO 115 K=1,NKP
        READ(3,20) IOVLB,IOVLE
        WRITE(8,20) IOVLB,IOVLE      
        ILOOP=IOVLE-IOVLB+2
        IF (IOVLB .EQ. 1) ILOOP=ILOOP-1
        IF (K .EQ. 1) THEN
          DO 100 LOQ=1,NEQU
            READ(3,90) IDAT(LOQ,1),IDAT(LOQ,2),DDX(LOQ),NDIVIS(LOQ)
   90       FORMAT(2A7,F10.4,I4)
  100     CONTINUE
        ENDIF
        DO 110 IL=1,ILOOP
          READ(3,50) (DD(IDD,IL),IDD=1,NEQU)
          WRITE(8,50) (DD(IDD,IL),IDD=1,NEQU)
  110   CONTINUE 
  115 CONTINUE     

      DO 310 IPRO=1,NPROJB
        IC=0
        DO 130 I=1,NEQU
          ACI1=IDAT(I,1)
          ACI2=IDAT(I,2)
          DIS=DDX(I)
          DO 120 J=1,IDMAX(IPRO)
            ACJ1=NOM1(J,IPRO)
            ACJ2=NOM2(J,IPRO)
            DMI=DTMIN(J,IPRO)
            DMA=DTMAX(J,IPRO)
            T1=(ACI1 .EQ. ACJ1)
            T2=(ACI2 .EQ. ACJ2)
            T3=(ACI1 .EQ. ACJ2)
            T4=(ACI2 .EQ. ACJ1)
            T1=(T1 .AND. T2 .OR. T3 .AND. T4)
            T5=((DIS .GT. DMI) .AND. (DIS .LT. DMA))
            IF ( .NOT. (T1 .AND. T5)) GOTO 120
            IC=IC+1
            IPROJB(IC,IPRO)=I
            GOTO 130
  120     CONTINUE
  130   CONTINUE
        NDPRB(IPRO)=IC

        IF (IC .NE. 0) THEN
          NBTOT(IPRO)=0
          IF (IVARYS .EQ. IVARYE) THEN
            WRITE(IOUT,135) IC
  135       FORMAT(/////,' Overlap population: ',I4,' bond type(s) ',
     .             'projected.',/)  
          ELSE
            WRITE(IOUT,140) IVARY,IC
  140       FORMAT(/,' Geometry variation #',I4,': ',I4,' bond ',
     .             'type(s) projected',/)
          ENDIF
          DO 160 I=1,IC
            J=IPROJB(I,IPRO)
            NBTOT(IPRO)=NBTOT(IPRO)+NDIVIS(J)
            WRITE(IOUT,150) IDAT(J,1),IDAT(J,2),DDX(J),NDIVIS(J)
  150       FORMAT(4X,A7,' <---> ',A7,'  with the distance ',F10.5,
     .             ' A, ',I2,' equivalent bond(s)')
  160     CONTINUE
          WRITE(IOUT,170) NBTOT(IPRO)
  170     FORMAT(/,'    Total of ',I3,' bond(s).',/)
        ELSE
          SLINE='no bond'
          CALL WRITEL(SLINE)
        ENDIF

        DO 180 IF=1,NSTEP
          B3(IF)=0.0D0
  180   CONTINUE

        REWIND 8
        DO 230 K=1,NKP
          READ(8,20) IOVLB,IOVLE
          ICUMUL=IOVLB-1
          ILOOP=IOVLE-IOVLB+2
          IF (IOVLB .EQ. 1) ILOOP=ILOOP-1
          DO 190 IL=1,ILOOP
            READ(8,50) (DD(IDD,IL),IDD=1,NEQU)
  190     CONTINUE
          IDKP=(K-1)*NDIM+1
          WEI=W(IDKP)
          M1=1
          M2=0
          DO 220 IRUN=1,NSTEP
            IF (IRUN .NE. 1) M1=M1+IACC(K,IRUN-1)
            M2=M2+IACC(K,IRUN)
C            IF ((M2 .LT. ICUMUL) .AND. (IRUN .EQ. 1)) THEN
C              SLINE='the integration requires levels below the '
C     .              //'limitation OVLPOP=m to n of EHMACC'
C              CALL WRITEL(SLINE)
C              CALL CLEXIT
C            ENDIF
            IF (M2 .GT. IOVLE) THEN
              SLINE='the integration requires levels above the '//
     .                 'limitation OVLPOP=m to n of EHMACC'
              CALL WRITEL(SLINE)
              CALL CLEXIT
            ENDIF
            DO 210 M=M1,M2
              IF (M .LT. ICUMUL) GOTO 210
              MM=M-ICUMUL+1
              DO 200 N=1,NDPRB(IPRO)
                NN=IPROJB(N,IPRO)
                B3(IRUN)=B3(IRUN)+DD(NN,MM)*WEI
  200         CONTINUE
  210       CONTINUE
  220     CONTINUE
  230   CONTINUE

        DIV=1.0D0
        IF (IAV .NE. 0) THEN
          DIV=DBLE(NBTOT(IPRO))
          B3(1)=B3(1)/DIV
        ENDIF         
        DO 240 IR=1,NSTEP
          IF (IR .NE. 1) B3(IR)=B3(IR)/DIV+B3(IR-1)
  240   CONTINUE

        IF (IVARYS .EQ. IVARYE) THEN
          IF (IAV .NE. 0) THEN
            WRITE(IOUT,250) IPRO,NBTOT(IPRO)
  250       FORMAT(///,5X,'Average overlap population for the ',
     .             'projection #',I2,' ,',I3,' bonds',//,1X,'   i',8X,
     .             'n0 ',9X,'n1 ',8X,'ef0',9X,'ef1',9X,'pop')
          ELSE
            WRITE(IOUT,260) IPRO,NBTOT(IPRO)
  260       FORMAT(///,5X,'Cumulated overlap population for the ',
     .             'projection #',I2,' ,',I3,' bonds',//,1X,'   i',8X,
     .             'n0 ',9X,'n1 ',8X,'ef0',9X,'ef1',9X,'pop')
          ENDIF
          DO 280 IR=1,NSTEP
            WRITE(IOUT,270) IR,B1(IR),B2(IR),B5(IR),B6(IR),B3(IR)
  270       FORMAT(1X,I4,6F12.4)
  280     CONTINUE
        ELSE
          IF (IAV .NE. 0) THEN
            WRITE(IOUT,290) IPRO,NBTOT(IPRO),LEVE,B3(NSTEP)
  290       FORMAT(' Average overlap population for the projection #',
     .             I2,' ,',I3,' bonds, ',I3,' electrons: ',F10.4) 
          ELSE
            WRITE(IOUT,300) IPRO,NBTOT(IPRO),LEVE,B3(NSTEP)
  300       FORMAT(' Cumulated overlap population for the projection #',
     .             I2,' ,',I3,' bonds, ',I3,' electrons: ',F10.4) 
          ENDIF
        ENDIF
  310 CONTINUE

      RETURN
      END
